struct KNotes {
	llist list;
	char edit_active;
	char txt_path[4096];
	dword buff, buff_size;
	int OpenTxt(dword file_path);
	int SaveTxt();
	int GetLineBufOffset(int searching_line);
	void ChangeNodeText(dword node_n, new_string);
	void DeleteCurrentNode();
	void DrawList();
	dword DrawLine(int line_n, draw_h);
};


int KNotes::OpenTxt(dword file_path)
{
	strcpy(#txt_path, file_path);
	if (buff) free(buff);
	if (GetFile(#buff, #buff_size, #txt_path))
	{
		list.count = chrnum(buff, '\n')+1;
		return 1;
	}
	else
	{
		debug(#txt_path);
		debug("File not exists");
		return 0;
	}
}


int KNotes::SaveTxt(dword file_path)
{
	if (file_path) strcpy(#txt_path, file_path);
	WriteFile(buff_size, buff, #txt_path);
}


//DeactivateList();


int KNotes::GetLineBufOffset(int searching_line)
{
	dword off, l=0;
	if (searching_line==0) return buff+2;
	for (off = buff; off < buff+buff_size; off++)
	{
		if (ESBYTE[off]=='\n') l++;
		if (l == searching_line) return off+4;
	}
}


void KNotes::ChangeNodeText(dword node_n, new_string)
{
	return;
}


void KNotes::DeleteCurrentNode()
{
	if (list.current == list.count-1)
	{
		ESBYTE[GetLineBufOffset(list.current)-2] = 0;
		list.current = list.count-2;
	}
	else
	{
		strcpy(GetLineBufOffset(list.current), GetLineBufOffset(list.current+1));		
	}
	buff_size = strlen(buff);
	buff = realloc(buff, buff_size);
	list.count--;
}


dword KNotes::DrawLine(int line_n, draw_h) {
	dword 
		COL_BOTTOM_LINE=0xE8EFF4,
		COL_BG,
		cur_line_text;
	char line_text[4096];
	if (line_n<0) return;
	DeleteButton(100+line_n);
	if (line_n==list.current) COL_BG = COL_BG_ACTIVE; else COL_BG = COL_BG_INACTIVE;
	DrawBar(list.x, line_n*list.line_h+list.y, RED_LINE_W, draw_h-1, COL_BG_INACTIVE);
	DrawBar(list.x+RED_LINE_W+1, line_n*list.line_h+list.y, list.w-RED_LINE_W-1, draw_h-1, COL_BG);
	if (draw_h!=list.line_h) 
	{
		COL_BOTTOM_LINE=COL_BG;
	}
	else
	{

		DefineButton(RED_LINE_W-CHECKBOX_SIZE/2+list.x, list.line_h*line_n+5+list.y, CHECKBOX_SIZE-1,CHECKBOX_SIZE-1, 500+line_n+BT_HIDE, 0); //checkbox
		cur_line_text = strcpyb(GetLineBufOffset(line_n)-2, #line_text, 0, "\n");
		if (ESBYTE[cur_line_text]=='-')
		{
			_PutImage(RED_LINE_W-CHECKBOX_SIZE/2+list.x, list.line_h*line_n+5+list.y, CHECKBOX_SIZE,CHECKBOX_SIZE, #checkbox);
			WriteText(list.x+RED_LINE_W+6, list.line_h*line_n+7+list.y, 0x80, 0, cur_line_text+2);
		}
		if (ESBYTE[cur_line_text]=='+')
		{
			_PutImage(RED_LINE_W-CHECKBOX_SIZE/2+list.x, list.line_h*line_n+5+list.y, CHECKBOX_SIZE,CHECKBOX_SIZE, 1*CHECKBOX_SIZE*CHECKBOX_SIZE*3+#checkbox);
			WriteText(list.x+RED_LINE_W+6, list.line_h*line_n+7+list.y, 0x80, 0x777777, cur_line_text+2);
			DrawBar(list.x+RED_LINE_W+6, list.line_h*line_n+11+list.y, strlen(cur_line_text)-2*6, 1, 0x444444);	//strike		
		}
	}
	DrawBar(list.x, line_n*list.line_h+draw_h-1+list.y, list.w, 1, COL_BOTTOM_LINE);
	DrawBar(list.x+RED_LINE_W, line_n*list.line_h+list.y, 1, draw_h, COL_RED_LINE);
	return cur_line_text;
}


void KNotes::DrawList()
{
	int i;
	for (i=0; i<list.visible; i++)
	{
		DrawLine(i, list.line_h);
	}
	DrawLine(i, -i * list.line_h + list.h - list.y);
}